pro set_channel_data,grism,N_pointing,USE_NG

common channel_data,n_frame,R,wavescale,lambda_cen,w_cover,w_cover2,fluxconv,QE,BG,readnoise,dark,PSF_FWHM,ADG

;0: NP or NG
;1: SG1
;2: SG2
;3: LG1
;4: LG2

case GRISM of
    
    0: begin
        if USE_NG then begin; return NG params
            R=135.*2.
            wavescale=0.010
            lambda_cen=3.6
            W_COVER=[2.5,4.7]
            fluxconv=0.714/0.85*0.57
        endif else begin        ; return NP params
            R=22.1*2.
            wavescale=0.058
            lambda_cen=3.5
            W_COVER=[1.9,5.0]
            fluxconv=0.714/0.85*0.90
         endelse
; common params for NP and NG
         n_frame=8*N_pointing
         w_cover2=[3.16-1.12/2.,3.16+1.12/2.]
         QE=0.8
         BG=0.495
         BG=5.464*QE
         readnoise=15           ; was 30; electron RMS
         dark=0.2
         PSF_FWHM=1.47          ; 1.43; N3
         ADG=10
     end
     
    1: begin
;        exptime[grism]=18.7     ; was 4.7
        n_frame=3*4*N_pointing  ; was 36=6*6
        R=47.4*2.
        wavescale=0.057
        lambda_cen=6.6
        W_COVER=[4.7,8.5]
;        w_cover20[1]=4.7 & w_cover21[1]=8.5
        w_cover2=[7.19-2.76/2.,7.19+2.76/2.]
        fluxconv=0.277/0.65*0.40
        QE=0.4
        BG=52.85
        BG=87.403*QE
        readnoise=14            ; electron RMS
        dark=27.4
        PSF_FWHM=1.22           ;1.70; S7
        ADG=6
    end
    
    2: begin
;        exptime[grism]=18.7     ; 16.4
        n_frame=3*4*N_pointing
        R=34.6*2.
        wavescale=0.10
        lambda_cen=10.5
        W_COVER=[7.3,14]
;        w_cover20[2]=7.3 & w_cover21[2]=14
        w_cover2=[10.39-4.56/2.,10.39+4.56/2.]
        fluxconv=0.405/0.65*0.40
        QE=0.4
        BG=190.96
        BG=321.375*QE
        readnoise=14            ; electron RMS
        dark=27.4
        PSF_FWHM=1.52           ; 2.30; S11
        ADG=6
    end
        
    3: begin
;        exptime[grism]=18.7     ; 16.4
        n_frame=3*4*N_pointing
        R=19.6*2.
        wavescale=0.173
        W_COVER=[10.0,18.9]
;        w_cover20[3]=10.0 & w_cover21[3]=18.9
        w_cover2=[15.56-6.0/2.,15.56+6.0/2.]
        lambda_cen=14.4
        fluxconv=0.353/0.65*0.44
        QE=0.4
        BG=390.8
        BG=587.881*QE
        readnoise=14            ; electron RMS
        dark=17.6
        PSF_FWHM=2.13           ; 2.70; L15
        ADG=6
    end
    
    4: begin
;        exptime[grism]=18.7     ; 16.4
        n_frame=3*4*N_pointing
        W_COVER=[17.5,25.5]
;        w_cover20[4]=17.5 & w_cover21[4]=25.5
        w_cover2=[23.04-5.34/2.,23.04+5.34/2.]
        R=27.0*2.
        wavescale=0.153
        lambda_cen=20.2
        fluxconv=0.126/0.65*0.44
        QE=0.4
        BG=125.6
        BG=418.485*QE
        readnoise=14            ; electron RMS
        dark=17.6
        PSF_FWHM=2.45           ; L24
        ADG=6
    end
    
;0: begin; consnstency check with N3
;exptime[grism]=49.1; was 49.1
;n_frame=6*N_pointing
;R=22.1*2.
;wavescale=0.6;0.058
;lambda_cen=3.2
;W_COVER=[2.6,3.8]
;w_cover20[0]=2.6
;w_cover21[0]=3.8
;fluxconv=0.714/0.9*0.90
;BG=0.495
;readnoise=30; was 30; electron RMS
;dark=0.2
;PSF_FWHM=1.43; N3
;ADG=10
;end

;ELSE: goto,retry_input
           
ENDCASE

end
